var express = require('express');
var bodyParser = require("body-parser");
var app = express();
var APP_PORT = 8088;
const fetch = require('node-fetch');
const fs = require('fs');

Polyglot.evalFile("ruby", "validator.rb");
var Validator = Polyglot.import('Validator');

Polyglot.evalFile("R", "functionGraph.r");
var plotFunction = Polyglot.import('plotFunction');

app.use(bodyParser.urlencoded({
    extended: false
}));
app.use(bodyParser.json());

function makeCsvFile(dico) {
    var res = 'Id,Date,Temp' + '\n'
    var i = 0;
    dico.forEach((value, index, self) => {
        //console.log(value, index, self)
        res += (1 + i).toString() + ',' + '(min) ' + value.forecastDate + ',' + value.minTemp.toString() + '\n';
        res += (2 + i).toString() + ',' + '(max) ' + value.forecastDate + ',' + value.maxTemp.toString() + '\n';
        i += 2;
    })
    console.log(res);
    // Asynchronous write
    //fs.writeFile('cerin.csv', res, (err) => {
    //   if(err) {
    //      return console.log(err);
    //}
    //console.log("The file was saved!");
    //});

    // Synchronous write
    // Write a string to another file and set the file mode to 0755
    try {
        fs.writeFileSync('cerin.csv', res, {
            mode: 0o755
        });
    } catch (err) {
        // An error occurred
        console.error(err);
    }
}

app.post('/graph', function(req, res) {
    let expr = req.body.expr;
    let errorMsg = Validator.validate(expr);
    if (errorMsg.length() == 0) {
        fetch('https://worldweather.wmo.int/fr/json/' + expr + '_fr.xml')
            .then(res => res.json())
            .then(json => {
                console.log(json);
                //console.log(json.city.forecast.forecastDay);
                makeCsvFile(json.city.forecast.forecastDay);
                res.send(plotFunction(json.city.cityName));
            });
    } else {
        res.send(errorMsg);
    }
});

app.use(express.static(__dirname + "/public"));
app.listen(APP_PORT, function() {
    console.log("Server listening on port " + APP_PORT);
});
